class GUI {
  
  private PImage[] bgImgs;
  private int bgShift = 0;
  private int transShift = 0;
  private float menuShift = 0;
  private PFont stratumFont82;
  private PFont stratumFont24;
  public AudioPlayer player;
  public AudioInput input;
  
  GUI () {
    size(800,600);
    init();
  }

  GUI (int w, int h) {
    size(w,h);
    init();
  }
  
  private void init() {
    bgImgs = new PImage[] { loadImage("img/diagmonds_1000.jpg"), loadImage("img/diagmonds_w_1000.jpg") };
    stratumFont82 = loadFont("data/Stratum2-Regular-82.vlw");
    stratumFont24 = loadFont("data/Stratum1-Regular-24.vlw");
    
    player = minim.loadFile("sound/Du Tonc - Surging Memories.mp3");
    input = minim.getLineIn();
    player.play();
    player.loop();
  }
  
  protected void drawStyle () {
    bgShift += 1;
    
    if (state.gameMode == State.GAME_MODE_PLAY) {
      if (state.guiMode == State.GUI_MODE_NORMAL) {
        image(bgImgs[0],-280 + (bgShift / 2 % 281), -(bgShift % 281));
        fill(255);
        
        if ( transShift > 0) {
          transShift = constrain(transShift-15,0,255);
          pushStyle();
          tint(255,transShift);
          image(bgImgs[1],-280 + (bgShift / 2 % 281), -(bgShift % 281));
          popStyle();
        }
        
      } else if (state.guiMode == State.GUI_MODE_INVERTED) {
        pushStyle();
        
          tint(255,60);
          image(bgImgs[1],-280 + (bgShift / 2 % 281), -(bgShift % 281));
          if ( transShift < 255) {
            transShift = constrain(transShift+15,0,255);
            tint(255,255-transShift);
            image(bgImgs[0],-280 + (bgShift / 2 % 281), -(bgShift % 281));
          }
        popStyle();
        fill(40);
      }
    } else {
      image(bgImgs[1],-280 + (bgShift / 2 % 281), -(bgShift % 281));
      fill(255);
    }
    
    noStroke();
  }
  
  protected void drawState (int gameMode) {
    
    drawStyle();
    
    switch(gameMode)
    {
    case State.GAME_MODE_MENU:
      draw_MENU();
      break;
    case State.GAME_MODE_PLAY:
      draw_PLAY();
      break;  
    case State.GAME_MODE_GAMEOVER:
      //drawGameOver();
      break;
    }
  }
  
  private void draw_MENU () {
    menuShift += sin(map(menuShift+10, 0, 80, 0, PI)) * 3;
    textFont(stratumFont24, 24);  
    pushStyle();
      textAlign(CENTER);
      fill(0,0,0,255*(menuShift/80));
      text("Press Space to Play", width/2, height/2 + 20 + (menuShift/80)*20);
    popStyle();
    pushStyle();
      textFont(stratumFont82, 82);
      textAlign(CENTER);
      fill(0,0,0,255*(menuShift/80));
      text("QUADRA PONG", width/2, height/2 + 20 - menuShift*0.5);
    popStyle();
  }
  
  private void draw_PLAY () {
    //
    pushStyle();
      textFont(stratumFont82, 82);
      textAlign(CENTER);
      text(state.score[0], width/2, 120 + 41);
      text(state.score[1], width - 120, height/2);
      text(state.score[2], width/2, height - 120);
      text(state.score[3], 120, height/2);
    popStyle();
  }
  
  private void draw_GAMEOVER () {
    fill(40);
    pushStyle();
      textFont(stratumFont82, 82);
      textAlign(CENTER);
      text(state.score[0], width/2, 120 + 41);
      text(state.score[1], width - 120, height/2);
      text(state.score[2], width/2, height - 120);
      text(state.score[3], 120, height/2);
    popStyle();
    
    pushStyle();
      textAlign(CENTER);
      fill(0,0,0,255*(menuShift/80));
      text("Press ENTER to RESTART", width/2-70, height/2-50, 140, 60);
    popStyle();
  }
}
