class Physics {
  
  final static int  HIT_NO     = 0;
  final static int  HIT_LEFT   = 1;
  final static int  HIT_RIGTH  = 2;
  final static int  HIT_TOP    = 3;
  final static int  HIT_BOTTOM = 4;
  
  public int startTime = millis();
  
  public List<PhysicsObject> objects;
  
  Physics () {
    objects = new ArrayList<PhysicsObject>();
  }
  
  protected void step () {
    for (PhysicsObject o : objects) {
      if ( o.getClass() == Ball.class) {
        for (PhysicsObject c : objects) {
          if ( c.getClass() == Plattform.class) {
            checkBall(o, c);
          }
        }
        //pongKeepTopBottom(o);
        //pongKeepAll(o); 
        pong(o);
      }
      if ( o.getClass() == GravityCenter.class) {
        for (PhysicsObject c : objects) {
          if ( c.getClass() == Ball.class) {
            ((GravityCenter)o).apply(c);
          }
        }
        //pongKeepTopBottom(o);
        //pongKeepAll(o); 
        pong(o);
      }
      o.step();
    }
  }
  
  protected void displayObjs () {
    for (PhysicsObject o : objects) {
      o.display();
    }
  }
  
  private void pong (PhysicsObject ball) {
   if (ball.getDir().x < 0 && ball.getPos().x < 0) {
      //left
      if (((Ball)ball).getLastTouch() != g.objects.get(3)) state.increaseScore(ball);
      ((Ball)ball).reset();
      
      ((Plattform)g.objects.get(3)).resetCombo();
      
    } else if (0 < ball.getDir().x && width < ball.getPos().x) {
      // right;
      if (((Ball)ball).getLastTouch() != g.objects.get(1)) state.increaseScore(ball);
      ((Ball)ball).reset();
      
      ((Plattform)g.objects.get(1)).resetCombo();
      
    } else if (ball.getDir().y < 0 && ball.getPos().y < 0) {
      // top
      if (((Ball)ball).getLastTouch() != g.objects.get(0)) state.increaseScore(ball);
      ((Ball)ball).reset();
      
      ((Plattform)g.objects.get(0)).resetCombo();
      
    } else if (0 < ball.getDir().y && height < ball.getPos().y) {
      // bottom
      if (((Ball)ball).getLastTouch() != g.objects.get(2))
      state.increaseScore(ball);
      ((Ball)ball).reset();
      
      ((Plattform)g.objects.get(2)).resetCombo();
    }
    
    
  }
  private void pongKeepTopBottom (PhysicsObject ball) {
    if (ball.getDir().x < 0 && ball.getPos().x < 0) {
      // left
    } else if (0 < ball.getDir().x && width < ball.getPos().x) {
      // right
    } else if ((ball.getDir().y < 0 && ball.getPos().y < 0) || (0 < ball.getDir().y && height < ball.getPos().y)) {
      ball.invertDir("y");
    }
  }
  private void pongKeepAll (PhysicsObject ball) {
    if ((ball.getDir().x < 0 && ball.getPos().x < 0) || (0 < ball.getDir().x && width < ball.getPos().x)) {
      ball.invertDir("x");
    } else if ((ball.getDir().y < 0 && ball.getPos().y < 0) || (0 < ball.getDir().y && height < ball.getPos().y)) {
      ball.invertDir("y");
    }
  }
  
 
  private void checkBall(PhysicsObject ball, PhysicsObject compareObj) {
    PVector hitPos = ball.getPos();
    float  hitV;
    float  speed;
    int col = checkCollision(ball.getPos().x, ball.getPos().y, ball.getDim().x/2, ball.getDir(), compareObj, hitPos);
    switch(col) {
      case HIT_LEFT:
        
        hitV = hitPos.y - (compareObj.getPos().y - compareObj.getDim().y/2);
        hitV = 1.0 / compareObj.getDim().y * hitV - 0.5;
        ball.setDir(ball.getDir().x, ball.getDir().y + hitV * 4);
        
        ball.invertDir("x");
        
        ball.setPos(hitPos.x - ball.getDim().x / 2, hitPos.y);
        ((Ball)ball).setLastTouch(compareObj);
        break;
      case HIT_RIGTH:
        
        hitV = hitPos.y - (compareObj.getPos().y - compareObj.getDim().y/2);
        hitV = 1.0 / compareObj.getDim().y * hitV - 0.5;
        ball.setDir(ball.getDir().x, ball.getDir().y + hitV * 4);
        
        ball.invertDir("x");
        
        ball.setPos(hitPos.x + ball.getDim().x / 2, hitPos.y);
        ((Ball)ball).setLastTouch(compareObj);
        break;
      case HIT_TOP:

        hitV = hitPos.x - (compareObj.getPos().x - compareObj.getDim().x/2);
        hitV = 1.0 / compareObj.getDim().x * hitV - 0.5;
        ball.setDir(ball.getDir().x + hitV * 4, ball.getDir().y);
        
        ball.invertDir("y");
        
        ball.setPos(hitPos.x, hitPos.y + ball.getDim().y/2);
        ((Ball)ball).setLastTouch(compareObj);
        break;
      case HIT_BOTTOM:
      
        hitV = hitPos.x - (compareObj.getPos().x - compareObj.getDim().x/2);
        hitV = 1.0 / compareObj.getDim().x * hitV - 0.5;
        ball.setDir(ball.getDir().x + hitV * 4, ball.getDir().y);
        
        ball.invertDir("y");
        
        ball.setPos(hitPos.x, hitPos.y - ball.getDim().y/2);
        ((Ball)ball).setLastTouch(compareObj);
        break; 
    }
  }
  
  private int checkCollision(float x, float y, float r, PVector objDir, PhysicsObject hitObj, PVector hitPos) {
    
    if (x + r >= hitObj.getPos().x - hitObj.getDim().x/2  && x -r <= hitObj.getPos().x + hitObj.getDim().x/2 &&
        y + r >= hitObj.getPos().y - hitObj.getDim().y/2 && y - r <= hitObj.getPos().y + hitObj.getDim().y/2)
    {
      PVector dir = objDir;
      dir.normalize();   
      
      PVector pObj = PVector.add(new PVector(x, y), PVector.mult(dir, r));
      PVector pObjPrev = PVector.sub(new PVector(x, y), PVector.mult(dir, r));

      PVector lt = new PVector(hitObj.getPos().x - hitObj.getDim().x/2, hitObj.getPos().y + hitObj.getDim().y/2);
      PVector rt = new PVector(hitObj.getPos().x + hitObj.getDim().x/2, hitObj.getPos().y + hitObj.getDim().y/2);
      PVector lb = new PVector(hitObj.getPos().x - hitObj.getDim().x/2, hitObj.getPos().y - hitObj.getDim().y/2);
      PVector rb = new PVector(hitObj.getPos().x + hitObj.getDim().x/2, hitObj.getPos().y - hitObj.getDim().y/2);

      PVector vecTop     = Util.segIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                             lt.x, lt.y, rt.x, rt.y);
      PVector vecBottom  = Util.segIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                            lb.x, lb.y, rb.x, rb.y);
      PVector vecLeft    = Util.segIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                             lt.x, lt.y, lb.x, lb.y);
      PVector vecRight   = Util.segIntersection(pObjPrev.x, pObjPrev.y, pObj.x, pObj.y, 
                                            rt.x, rt.y, rb.x, rb.y);
      
      if (vecTop != null) {
        hitPos.set(vecTop);
        return HIT_TOP;
      } else if(vecBottom != null) {
        hitPos.set(vecBottom);
        return HIT_BOTTOM;
      } else if (vecLeft != null) {
        hitPos.set(vecLeft);
        return HIT_LEFT;
      } else if (vecRight != null) {
        hitPos.set(vecRight);
        return HIT_RIGTH;
      } else {
        return HIT_NO;
      }

    }
    return HIT_NO;
  }
  
  protected ArrayList<PhysicsObject> getBallsByDistance(PhysicsObject refObj) {
    ArrayList<PhysicsObject> retList = new ArrayList<PhysicsObject>();
    for (PhysicsObject o : objects) {
      if (o.getClass() == Ball.class) {
        //println(degrees(PVector.angleBetween(PVector.sub(o.getPos(), refObj.getPos()), o.getDir())));
        //println(pow(refObj.getPos().x - o.getPos().x, 2) + pow(refObj.getPos().y - o.getPos().y, 2));
        if ( 
              (45 <  degrees(PVector.angleBetween(PVector.sub(o.getPos(), refObj.getPos()), o.getDir()))
               ||
               135 >  degrees(PVector.angleBetween(PVector.sub(o.getPos(), refObj.getPos()), o.getDir()))
              )
             &&
             pow(refObj.getPos().x - o.getPos().x, 2) + pow(refObj.getPos().y - o.getPos().y, 2)
             <
             pow(width/1.5,2)
           )
        {
          if ( !retList.isEmpty()
               &&
               pow(refObj.getPos().x - o.getPos().x, 2) + pow(refObj.getPos().y - o.getPos().y, 2)
               <
               pow(refObj.getPos().x - retList.get(0).getPos().x, 2) + pow(refObj.getPos().y - retList.get(0).getPos().y,2)
             )
           {
             retList.add(0,o);
           } else {
             retList.add(o);     
           }
         }
      }
    }
    return retList;
  }
  
  /*protected PhysicsObject getClosestBall (PhysicsObject refObj) { 
    for (int i = 5; i < objects.size(); i++) {
        
        if ( pow(refObj.getPos().x - retBall.getPos().x, 2) + pow(refObj.getPos().y - retBall.getPos().y, 2)
             >
             pow(refObj.getPos().x - objects.get(i).getPos().x, 2) + pow(refObj.getPos().y - objects.get(i).getPos().y,2)
           ) {
          retBall = objects.get(i);     
        }
    }
    if (objects.size() > 5) {
      for (int i = 5; i < objects.size(); i++) {
        
        if ( pow(refObj.getPos().x - retBall.getPos().x, 2) + pow(refObj.getPos().y - retBall.getPos().y, 2)
             >
             pow(refObj.getPos().x - objects.get(i).getPos().x, 2) + pow(refObj.getPos().y - objects.get(i).getPos().y,2)
           ) {
          retBall = objects.get(i);     
        }
      }
    }
    return retBall;
  }*/

  protected void addObject (PhysicsObject newObj) {
    objects.add(newObj);
  }
  protected void addObjects (ArrayList<PhysicsObject> addedObjects) {
    for (PhysicsObject a : addedObjects) {
      objects.add(a); 
    }
  }
  protected List<PhysicsObject> getObjects () {
    return objects;
  }
  protected void removeAll () {
    for (PhysicsObject o : objects) {
      objects.remove(o);
    }
  }
}


