class State {
  
  final static int GAME_MODE_MENU          = 0;
  final static int GAME_MODE_PLAY          = 1;
  final static int GAME_MODE_GAMEOVER      = 2;

  
  final static int GUI_MODE_NORMAL = 0;
  final static int GUI_MODE_INVERTED = 1;
  
  int gameMode = GAME_MODE_MENU;
  int guiMode = GUI_MODE_NORMAL;
  
  int transitionToMode = GAME_MODE_MENU;
  int transitionTime = 255;
  int transitionTimeCurrent = 255;
  
  int [] score;
  
  State () {
    score = new int [] {0,0,0,0};
  }
  
  protected void startGame() {
    gameMode = GAME_MODE_PLAY;
    g.startTime = millis();
  }
  
  protected void step() {
    if (gameMode == GAME_MODE_PLAY) {
      if ((millis() - g.startTime) % 50000 > 40000) {
        guiMode = GUI_MODE_INVERTED;
      } else {
        guiMode = GUI_MODE_NORMAL;
      }
      
      if (guiMode == GUI_MODE_INVERTED && g.objects.size() < 15) {
        //g.objects.add(new GravityCenter(300,0.01, height/2, width/2));
        for (int i = g.objects.size(); i < 15; i++) {
          g.objects.add(new Ball(20.0, 6, random(-height/4,height/4)+height/2,random(-width/4,width/4)+width/2, random(-1,1),random(-1,1)));
        }
      } else if (guiMode == GUI_MODE_NORMAL && g.objects.size() > 6) {
        int count = 0;
        for (Iterator<PhysicsObject> it = g.objects.iterator(); it.hasNext(); ) {
          PhysicsObject o = it.next();
          
          if (count > 5) {
            it.remove();
          }
          count++;
        }
      }
    }
  }
  
  protected void startMenu() {
    gameMode = GAME_MODE_PLAY;
  }
  
  protected void endGame() {
    gameMode = GAME_MODE_GAMEOVER;
    println("gameover");
  }
  
  protected void increaseScore(PhysicsObject iObj) {
    if (((Ball)iObj).getLastTouch() == g.objects.get(0)) {
     state.score[0] += 1;
     ((Plattform)g.objects.get(0)).triggerCombo();
    } else if (((Ball)iObj).getLastTouch() == g.objects.get(1)) {
     state.score[1] += 1;
     ((Plattform)g.objects.get(1)).triggerCombo();
    } else if (((Ball)iObj).getLastTouch() == g.objects.get(2)) {
     state.score[2] += 1;
     ((Plattform)g.objects.get(2)).triggerCombo();
    } else if (((Ball)iObj).getLastTouch() == g.objects.get(3)) {
     state.score[3] += 1;
     ((Plattform)g.objects.get(3)).triggerCombo();
    }
    ((Ball)iObj).resetLastTouch();
    
    for (int i = 0; i < score.length; i++) {
      if (score[i] >= 15) {
        endGame();
      }
    }
  }
}
